#define GL_GLEXT_PROTOTYPES
#include <GL/gl.h>
#include <GL/glext.h>

#include "config.h"
#include <FL/Fl.H>
#include <FL/gl.h>
#include <FL/Fl_Window.H>
#include <FL/Fl_Gl_Window.H>


class Gl_Window : public Fl_Gl_Window
{
	void draw();
	void init();
	int handle(int);

	public:
	Gl_Window(int x,int y,int w,int h,const char *l=0)
		: Fl_Gl_Window(x,y,w,h,l) { init();}
	Gl_Window(int w,int h,const char *l=0)
		: Fl_Gl_Window(w,h,l) { init();}
};
void Gl_Window::init()
{
}
void Gl_Window::draw()
{
	if (!valid())
	{
		glLoadIdentity();
		glOrtho( 0,w(),h(),0,0.0f,100.0f);
		glClearColor( 1,1,1,0.5f);
		glClearDepth( 1.0f);
	}
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	float triangle_vertex[]=
	{
		150,10,		//vertex 1
		280,250,	//vertex 2
		20,250		//vertex 3
	};
	float triangle_color[]=
	{
		1,0,0,
		0,1,0,
		0,0,1
	};
	
	float para_vertex[]=
	{
		50,270,
		100,30,
		54,270,
		104,30,
		58,270,
		108,30
	};
	float para_color[]=
	{
		1,1,1,
		1,1,1,
		1,0,0,
		1,0,0,
		1,1,1,
		1,1,1
	};
	
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_COLOR_ARRAY);
	
	glVertexPointer(2, GL_FLOAT, 0, triangle_vertex);
	glColorPointer(3, GL_FLOAT, 0, triangle_color);
	glDrawArrays(GL_TRIANGLES, 0, 3);
	
	glVertexPointer(2, GL_FLOAT, 0, para_vertex);
	glColorPointer(3, GL_FLOAT, 0, para_color);
	glDrawArrays(GL_TRIANGLE_STRIP, 0, 6);
	
	glDisableClientState(GL_VERTEX_ARRAY);
	glDisableClientState(GL_COLOR_ARRAY);
}

int Gl_Window::handle(int e)
{
	return Fl_Gl_Window::handle(e);
}

int main(int argc, char **argv)
{
	Gl_Window gl_wnd( 300,300,"Hello world fltk-opengl");
	gl_wnd.show();
	return Fl::run();
}
